

do
	local FILENAME = "./AI/USER_AI/temp/msgqueue.lua"
	local queue = List.new()
	
	local function LoadKeyMsgs()
		local chunk = loadfile( FILENAME )
		if not chunk then return end
		chunk = chunk()
		if not chunk then return end
		for i,v in ipairs( chunk ) do
			List.pushright( queue, v )
		end
		local f = io.open( FILENAME, "w+")	-- gɂ
		f:close()
	end
	
	function GetKeyMsg()
		if List.size( queue ) == 0 then
			LoadKeyMsgs()
		end
		local msg = List.popleft( queue )
		return msg
	end
	
	local list = List.new()
	
	function SetKeyConfig( mod, vk, func )
		List.pushright( list, { mod, vk, func } )
	end
	
	function DispatchKeyMsgs()
		LoadKeyMsgs()
		for k,v in pairs( queue ) do
			for k2,v2 in pairs( list ) do
				if type( v2 ) == "table" then
					local mod, vk, func = unpack( v2 )
					if type( v ) == "table" and v.mod == mod and v.vk == vk then
						func( k2 )
					end
				end
			end
		end
		queue = List.new()	-- List.clear()̓oOĂ(Listipairs͎gȂۂ)̂ō蒼
	end
end
