

-- Cxgo^

if Settings.SAFE_STARTING then
	local enabled
	
	SetEvent( EVENT_BEGIN_STATE, _and( Settings.AI_ACTIVE, once() ),	-- mANeBu
		function()
			Settings.AI_ACTIVE = nil	-- false ƁA蓮؂ւȂǂ false ɕύXĂ킩Ȃ̂ŁAnil g
			enabled = true
		end )

	if Settings.CANCEL_SAFE_STARTING_TIME then
		local start = false
		local t = timer( Settings.CANCEL_SAFE_STARTING_TIME )
		timer_start( t )
		
		SetEvent( EVENT_BEGIN_STATE,
			function()
				return enabled
			end,
			function()
				if not start and t() then	-- Ԍo
					if Settings.AI_ACTIVE == nil then	-- ق̃CxgȂǂŐ؂ւĂȂ
						Settings.AI_ACTIVE = true	-- ANeBuɖ߂
					end
					start = true
				end
			end )
	end
end

SetEvent( EVENT_BEGIN_STATE, _and( Settings.USE_MOBDATA, once() ),
	function()
		local t = GetTick()
		
		local mobdata = loadfile( PACKAGE_DIR.."/mobdata.lua")
		if mobdata then mobdata() end	-- t@CΓǂݍ
		
		IsIgnoreType( 0 )	-- OLbVĂ
		IsActivateType( 0 )
		
		local t2 = GetTick()
		TraceAI( "MobData Load: "..tostring( t2 - t ).." msec" )
	end )

if Settings.USE_MONSTER_PRIORITY then	-- MobDataǂݍ݌AO
	SetEvent( EVENT_BEGIN_STATE, once(),
		function()
			local priority = {}
			for i,v in ipairs( Settings.MONSTER_PRIORITY ) do
				if type( v ) == "string" then
					local id = GetMobIdByName( v )
					if id then	-- OȂ
						table.insert( priority, id )
					end
				else
					table.insert( priority, v )
				end
			end
			Settings.MONSTER_PRIORITY = priority
		end )
end

SetEvent( EVENT_BEGIN_STATE, once(),	-- OIDN[Wɕϊ
	function()
		local priority = {}
		for i,v in ipairs( Settings.ENEMY_PRIORITY ) do
			if type( v ) == "string" then
				v = GetMobIdByName( v )
			end
			if v then	-- OɐĂ
				if type( v ) == "number" then	-- IDw肳Ă鎞
					v = monster_id( v )
				end
				table.insert( priority, v )
			end
		end
		Settings.ENEMY_PRIORITY = priority
	end )

SetEvent( EVENT_BEGIN_STATE, _and( Settings.FRIEND, once() ),	-- NƂƂɃthXgǂ
	function()
		LoadFriendList()
	end )

if Settings.USE_MAP then
	
	local function LoadMapFile( file )
		local t = GetTick()
		
		local map = loadfile( PACKAGE_DIR.."/MAP/"..file..".lua")
		if map then
			map()	-- t@CΓǂݍ
		else
			TraceAI("Load Map Error")
		end
		
		local t2 = GetTick()
		TraceAI( "Load Map: "..file.." "..tostring( t2 - t ).." msec" )
	end
	
	SetEvent( EVENT_BEGIN_STATE,	-- }bvR[hǂݍ
		true,
		function()
			local mapcode = GetCurrentMapCode()
			-- }bv܂ǂݍłȂA}bvR[hύXꂽ}bvt@Cǂݍ
			if Settings._MAPCODE == nil or mapcode ~= Settings._MAPCODE then
				MAP = nil	-- GCΏۂ
				collectgarbage()	-- }bvǂݍޑOɕsv̂Ă
				if mapcode then	-- }bvR[hw肳ĂȂ
					LoadMapFile( mapcode )
					Settings._MAPCODE = mapcode
				end
			end
		end )
end

--[[
SetEvent( EVENT_BEGIN_STATE, true,	-- eXgR[h
	function()
	end )
--]]

do
	local x, y, motion, timestamp = -1, -1, -1, os.time()	-- Q΍
	SetEvent( EVENT_END_STATE, Settings.EXIT_TIME,
		function()
			local x2, y2 = GetV( V_POSITION, GetV( V_OWNER, MyID ) )
			local motion2 = GetV( V_MOTION, GetV( V_OWNER, MyID ) )
			if x ~= x2 or y ~= y2 or motion ~= motion2 then
				x, y, motion = x2, y2, motion2
				timestamp = os.time()
				return
			end
			local diff = os.difftime( os.time(), timestamp )
			if Settings.EXIT_SIGNAL and diff >= Settings.EXIT_TIME * Settings.EXIT_SIGNAL_PERCENTAGE * 0.01 then
				MoveToOwner( MyID ) 	-- P~̎낤낷
			end
			if diff >= Settings.EXIT_TIME then	-- oߎԂ߂I
				os.exit()
			end
		end )
end

SetEvent( EVENT_BEGIN_STATE,
	_and( Settings.TRACE_ACTORS_INFO, timer( Settings.TRACE_ACTORS_INFO_INTERVAL ) ),
	function()
		for i,v in ipairs( GetActors() ) do
			TraceObject( v )
		end
	end )

SetEvent( EVENT_BEGIN_STATE, once(),
	function()
		math.randomseed( GetTick() )
	end )

function UseAttackSkill( enemy )	-- UXLg
	local ht = GetV( V_HOMUNTYPE, MyID )
	if IsFamily( ht, FILIR ) then	-- AttackSightɓȂĂXL
		SkillObject( MyID, Eval( Settings.SELF_SKILL_MOONLIGHT_LEVEL ), SKILL_MOONLIGHT, enemy )
		return true
	elseif IsFamily( ht, VANILMIRTH ) then
		SkillObject( MyID, MAXLV_CAPRICE, SKILL_CAPRICE, enemy )
		return true
	end
	return false
end

function AllowAttackSkill( enemy )
	if not Contains( { CHASE_ST, ATTACK_ST }, MyState ) then	-- UǐՒł͂Ȃ
		return false
	end
	local ty = GetType( enemy )
	if ty == -1 then	-- SIuWFNg
		return false
	end
	if Settings.USE_MOBDATA and Settings.NO_USE_SKILL_MONSTER_LEVEL then	-- w背xȉȂ
		local lv = GetMobInfo( M_V_LV, ty )
		if lv and lv <= Settings.NO_USE_SKILL_MONSTER_LEVEL then
			return false
		end
	end
	if IsFamily( GetV( V_HOMUNTYPE, MyID ), VANILMIRTH ) then	-- XLJvXȂ
		if Settings.USE_MOBDATA and Settings.NO_USE_MAGIC_MDEF then 	-- MDEF
			local mdef = GetMobInfoEx( Settings.NO_USE_MAGIC_MDEF_TYPE, ty )
		--	TraceAI("MDEF: "..tostring(mdef).." type:"..tostring(ty) )
			if mdef and mdef >= Settings.NO_USE_MAGIC_MDEF then
				return false
			end
		end
		if Settings.USE_MOBDATA and Settings.NO_USE_MAGIC_NOT_EFFECTIVE_ATTRIBUTE then	-- 
			local attr = GetMobInfo( M_V_ATT, ty )
			local attrlv = GetMobInfo( M_V_ATTLV, ty )
		--	TraceAI(": "..tostring(attr).." "..tostring(attrlv) )
			if attr and attrlv then
				if attr == M_ATT_HOLY and attrlv >= 2 then
					return false
				elseif attr == M_ATT_DARK and attrlv >= 3 then
					return false
				end
			end
		end
	end
	return enemy > 0 and IsEnemy( MyID, enemy ) and not IsNaturalObject( enemy )
end

if Settings.SELF_SKILL then 	-- I[gXL
	local t = timer_start( tick_timer( Settings.SELF_SKILL_DELAY ) )
	local enemy 	-- GIDƎs
	local count = 0
	local burst 	-- o[Xg
	local rivals = {}
	
	SetEvent( EVENT_BEGIN_STATE,
		_and( Settings.SELF_SKILL_RIVAL_BURST, once() ),
		function()
			rivals = ResolveMobName( Settings.SELF_SKILL_RIVAL_TABLE )	-- O
		end )
	
	SetEvent( EVENT_BEGIN_STATE,	-- o[Xg
		function()
			burst = false
			if not AllowAttackSkill( MyEnemy ) then
				return burst
			end
--[[		
			local defs = GetMobInfoEx( DEF_SUB, GetType( MyEnemy ) )
			local defd = GetMobInfoEx( DEF_DIV, GetType( MyEnemy ) )
			local deft = GetMobInfoEx( DEF_TOTAL, GetType( MyEnemy ) )
			TraceAI("Def div:"..tostring(defd).." sub:"..tostring(defs).." total:"..tostring(deft))
			local mdefs = GetMobInfoEx( MDEF_SUB, GetType( MyEnemy ) )
			local mdefd = GetMobInfoEx( MDEF_DIV, GetType( MyEnemy ) )
			local mdeft = GetMobInfoEx( MDEF_TOTAL, GetType( MyEnemy ) )
			TraceAI("MDef div:"..tostring(mdefd).." sub:"..tostring(mdefs).." total:"..tostring(mdeft))
--]]		
			if GetPercentSP( MyID ) < Settings.SELF_SKILL_BURST_PERCENTAGE then
				return burst
			end
			if not burst and Settings.SELF_SKILL_RIVAL_BURST then
				if Contains( rivals, GetType( MyEnemy ) ) then
					TraceAI("Burst Reason: RIVAL TYPE "..tostring(GetType( MyEnemy )) )
					burst = true
				elseif Settings.USE_MOBDATA and Settings.SELF_SKILL_RIVAL_LEVEL then
					local lv = GetMobInfo( M_V_LV, GetType( MyEnemy ) )
					if lv and lv >= Settings.SELF_SKILL_RIVAL_LEVEL then
						TraceAI("Burst Reason: RIVAL LEVEL HIGHER "..tostring(lv) )
						burst = true
					end
				end
			end
			if not burst and Settings.SELF_SKILL_MH_BURST then
				local mobs = SelectActor( MyID, AllowActiveTargetting ) 	-- t[ȓG̐擾
				if table.getn( mobs ) >= Settings.SELF_SKILL_MH_COUNT then
					TraceAI("Burst Reason: MH "..tostring(table.getn( mobs )) )
					burst = true
				end
			end
			if not burst and Settings.USE_MOBDATA and Settings.SELF_SKILL_HIGH_DEF_BURST then
				local def = GetMobInfoEx( Settings.SELF_SKILL_HIGH_DEF_TYPE, GetType( MyEnemy ) )
				if def and def >= Settings.SELF_SKILL_HIGH_DEF then
					TraceAI("Burst Reason: HIGH DEF "..tostring(def) )
					burst = true
				end
			end
			return burst
		end,
		function()
			if not t() then 	-- fBCł͂Ȃ
				return
			end
			TraceAI("Burst Skill")
			UseAttackSkill( MyEnemy )
		end )
	
	SetEvent( EVENT_BEGIN_STATE,
		function()
			if MyEnemy ~= enemy then
				enemy = MyEnemy
				count = 0	-- Zbg
			end
			count = count + 1	-- JE^OɍXV
			
			if burst then	-- o[Xg͐pCxgɂ܂
				return false
			end
			return GetPercentSP( MyID ) >= Settings.SELF_SKILL_PERCENTAGE	-- SP̊ȏ
		end,
		function()
			if IsFamily( GetV( V_HOMUNTYPE, MyID ), LIF ) then
				local owner = GetV( V_OWNER, MyID )
				if GetPercentHP( owner ) < Settings.SELF_HEALING_PERCENTAGE then
					if not t() then 	-- fBCł͂Ȃ
						return
					end
					SkillObject( MyID, MAXLV_TOUCH_OF_HEAL, SKILL_TOUCH_OF_HEAL, MyID )
					return	-- LIF ͍UXLȂ
				end
			end
			if AllowAttackSkill( MyEnemy ) then
				if Settings.SELF_SKILL_FIRST_ATTACK then
					if count ~= 1 then
						return
					end
				else
					local x = GetPercentSP( MyID )
					local a = (x^2-x*2) / 100
					local r = math.random( 100 )
		--			a = a * ( a / 100 )
					a = a / count	-- XLs񐔂ɂ킹Ċm
					TraceAI("Try Skill: a="..tostring(a).." r="..tostring(r).." sp="..tostring(x) )
					if a <= r then
						return
					end
				end
				if not t() then 	-- fBCł͂Ȃ
					return
				end
				UseAttackSkill( MyEnemy )
			end
		end )
end

if Settings.SELF_BUFF then
	
	SetSkillInterval( LIF, Settings.SELF_BUFF_MIN_SP,
		Settings.SELF_BUFF_EMERGENCY_AVOID_DELAY,
		Settings.SELF_BUFF_EMERGENCY_AVOID_LEVEL, SKILL_EMERGENCY_AVOID )	-- ً} ͊Xł펞Ă݂
	
	local fight
	
	SetEvent( EVENT_BEGIN_STATE,
		function()
			if fight then
				return false
			end
			for i,v in ipairs( GetActors() ) do
				if IsMonster( v ) == 1 then
					fight = true
					return true	-- G𔭌^C}[Jn
				end
			end
			return false
		end,
		function()
			SetSkillInterval( AMISTR, Settings.SELF_BUFF_MIN_SP,
				Settings.SELF_BUFF_DEFENCE_DELAY,
				Settings.SELF_BUFF_DEFENCE_LEVEL, SKILL_DEFENCE )	-- fBtFX
			
			SetSkillInterval( FILIR, Settings.SELF_BUFF_MIN_SP,
				Settings.SELF_BUFF_FLEET_MOVE_DELAY,
				Settings.SELF_BUFF_FLEET_MOVE_LEVEL, SKILL_FLEET_MOVE )	-- t[g[u
		end )
end

do
	local v = 0
	local range = 3
	local angle = 0.80
	local clock = 0
	local speed = 350
	
	function CircleTrain( owner )	-- Ql: http://www.kogarashi.jp/0-material/ ǂǂAI
		if clock > GetTick() then
			return nil
		end
		clock = GetTick() + speed
		
		local ox, oy = GetV( V_POSITION, owner )
		v = v + 1
		if v == 1 then
			return ox - math.ceil( range * angle ), oy-math.ceil(range*angle)	--2
		elseif v == 2 then
			return ox - range,oy			--3
		elseif v == 3 then
			return ox - math.ceil(range*angle),oy+math.ceil(range*angle)	--4
		elseif v == 4 then
			return ox, oy+range			--5
		elseif v == 5 then
			return ox + math.ceil( range * angle ), oy+math.ceil(range*angle)	--6
		elseif v == 6 then
			return ox+range,oy			--7
		elseif v == 7 then
			return ox+math.ceil(range*angle),oy-math.ceil(range*angle)	--8
		elseif v == 8 then
			v = 0
			return ox,oy-range			--1
		else
			return nil
		end
	end
end

function GetTargetCount( id )
	local count = 0
	for i,v in ipairs( GetActors() ) do
		if id == GetV( V_TARGET, v ) then
			count = count + 1
		end
	end
	return count
end

do
	local disabled = false
	
	SetEvent( EVENT_BEGIN_STATE,
		le( bind( GetPercentHP, ref("MyID") ), Settings.ESCAPE_HP_PERCENTAGE ),	-- HPȉȂ
		function()	-- ܂ɔĂȂ̂ŁAdisabled ֘AɃoO邩H
			if GetTargetCount( MyID ) == 0 then
				disabled = false
				return
			end
			if Contains( { ESCAPE_ST, ATTACK_OBJECT_CMD_ST, MOVE_CMD_ST }, MyState ) then	-- Alt+ENbN̍Uړ߂̓X[
				disabled = true
				return
			end
			if disabled then
				if Contains( { CHASE_ST, ATTACK_ST, HOLD_CMD_ST }, MyState ) then	-- U܂̓z[h܂ł̓X[
					TraceAI("Escape: "..tostring(MyState))
					return
				else
					disabled = false
				end
			end
			
			TraceAI("Enter Escape: "..tostring(MyState))
			MyState = ESCAPE_ST
		end )
end

if Settings.CANCEL_HOLD_TIME then
	local t
	SetEvent( EVENT_BEGIN_STATE,	-- z[hԂ
		function()
			return Settings.CANCEL_HOLD_TIME and ( MyState == HOLD_CMD_ST or t )	-- HOLD_ST ^C}[̏ꍇ
		end,
		function()
			if not t then
				t = timer( Settings.CANCEL_HOLD_TIME )
				t()
			else
				if MyState ~= HOLD_CMD_ST then	-- z[hԂړ߂ȂǂŃLZꂽ̂ȂA^C}[Zbg
					t = nil
					return
				end
				if t() then
					t = nil
					MyState = IDLE_ST
				end
			end
		end )
end

function AllowInterruptCasting( v )	-- v ɑ΂rWQ邩ǂ
	if IsFriend( v ) then	-- V[Y[hɂāAΏۂFBȂrWQ͂Ȃ
		return false
	end
	local target = GetV( V_TARGET, v )
	if not( target == MyID or target == GetV( V_OWNER, MyID ) or IsFriend( target ) ) then
		return false
	end
	if GetV( V_TARGET, MyID ) == v or GetV( V_TARGET, GetV( V_OWNER, MyID ) ) == v then	-- ̓GUȂrWQȂ FB̃^QmF͂߂ǂȂ̂ŃiV
		return false
	end
	if Settings.INTERRUPT_CASTING_DISTANCE and GetDistance2( MyID, v ) > Settings.INTERRUPT_CASTING_DISTANCE then	-- ͈͊OȂfalse
		return false
	end
	if Settings.NO_INTERRUPT_CASTING_MONSTER_LEVEL and GetMobTable() then	-- xw肪LȂ
		local lv = GetMobInfo( M_V_LV, GetType( v ) )
		if lv and lv <= Settings.NO_INTERRUPT_CASTING_MONSTER_LEVEL then
			return false
		end
	end
	if IsBioplantType( GetType( v ) ) then	-- WIl̃q[͎זȂ
		return false
	end
	if IsNaturalObjectType( GetType( v ) ) then 	-- }XtBA[o^ꍇłWQȂ
		return false
	end
	return true
end

if Settings.INTERRUPT_CASTING then	-- rWQ
	SetEvent( EVENT_BEGIN_STATE,
		function()
			return true 	-- ɉrWQĂ݂
		--	return Contains( { CHASE_ST, ATTACK_ST, IDLE_ST }, MyState )
		end,
		function()
			for i,v in ipairs( GetActors() ) do
				if IsMonster(v) == 1 and GetV( V_MOTION, v ) == MOTION_CASTING then
					if AllowInterruptCasting( v ) then
						MyEnemy = v
						MyState = INTERRUPT_ST
						return
					end
				end
			end
		end )
end

do
	local setting
	
	SetEvent( EVENT_BEGIN_STATE,
		le( bind( GetPercentHP, ref("MyID") ), Settings.DEACTIVATE_HP_PERCENTAGE ),	-- HPȉȂmANeBu
		function()
			if Settings.AI_ACTIVE and not setting then	-- setting ̍XV͈񂵂sȂBi[U[R}hȂǂł̃ANeBuDj
				setting = Settings.AI_ACTIVE
				Settings.AI_ACTIVE = false
			end
		end )
	SetEvent( EVENT_BEGIN_STATE,
		gt( bind( GetPercentHP, ref("MyID") ), Settings.DEACTIVATE_HP_PERCENTAGE ),	-- HPȏȂANeBu
		function()
			if setting then
				Settings.AI_ACTIVE = setting
				setting = nil
			end
		end )
end

do
	local ignores = { n = 0 }
	
	SetEvent( EVENT_BEGIN_STATE,
		_or( Settings.HOMUN_MARKING, Settings.PET_MARKING ),	-- s
		function()
			for i,v in ipairs( GetActors() ) do
				if v ~= MyID and v < 100000 then	-- vC[ł͂Ȃ
					if not Contains( ignores, v ) and AllowMarking( v ) then
						if ( Settings.HOMUN_MARKING and IsHomunclus( v ) ) or ( Settings.PET_MARKING and IsPet( v ) ) then
							ignores.n = ignores.n + 1
							ignores[ ignores.n ] = v	-- x͖̂
							
							MyState = FAVOR_ST
							MyEnemy = v
							MyDestX, MyDestY = 0, 0
							return
						end
					end
				end
			end
		end )
end

function GetSinglePlayerByPosition( x, y )	-- wʒuɂvC[zԂ
	for i,v in ipairs( GetActors() ) do
		if IsPlayer( v ) == 1 or IsHomunclus( v ) then
			local ax, ay = GetV( V_POSITION, v )
			if x == ax and y == ay then 	-- v wĂȂ
				return v
			end
		end
	end
	return nil
end

-- { config.lua ̖ɏׂH

if Settings.ALTERNATIVE_KEY_CONFIG then
	SetUserCommand( SKILL_OBJECT_CMD, false,	-- XLx̃R}h蓖
		function( id, cmd, level, skill, id )
			return TranslateSkillCommand( level, skill, id )
		end )
end

if Settings.FRIEND then
	SetUserCommand( MOVE_CMD, false,	-- FBo^
		function( id, cmd, x, y )
			local v = GetSinglePlayerByPosition( x, y )
			if not v then
				return false
			end
			
			if IsFriend( v ) then
				UnregisterFriend( v )
			else
				RegisterFriend( v )	-- FBo^ɉ
				if Settings.FRIEND_MARKING and AllowMarking( v ) then
					MyState = FAVOR_ST
					MyEnemy = v
					MyDestX, MyDestY = 0, 0
				end
			end
			return true
		end )
end

do
	local step	-- ՂԑJ
	local target
	
	SetUserCommand( MOVE_CMD, false,	-- I[i[Ϗ  ̕ӂ܂c
		function( id, cmd, x, y )
			if not step then	-- Xebv1
				target = GetSinglePlayerByPosition( x + 1, y )
			elseif step then	-- Xebv2
				local v = GetSinglePlayerByPosition( x - 1, y )
				if v ~= target then 	-- vC[Xebv1ƈقȂĂ
					step = false	-- Xebv1֖߂
					return false
				end
				target = v
			end
			if target then
				if step then
					if target == GetV( V_OWNER, MyID ) then	-- I[i[Ϗ
						SetVirtualOwner( MyID )
					elseif target == MyID then	-- zgΏۂƂĂȂׂ͈͓ėFBo^
						if Settings.FRIEND then
							local owner = GetV( V_OWNER, MyID )
							for i,v in ipairs( GetActors() ) do
								if v ~= MyID and v ~= owner and (IsPlayer( v ) == 1 or IsHomunclus( v )) then 	-- vC[zo^
									if not Settings.REGISTER_FRIEND_DISTANCE or GetDistance2( owner, v ) <= Settings.REGISTER_FRIEND_DISTANCE then	-- o^͈͓Ȃ
										RegisterFriend( v )
									end
								end
							end
						end
					else
						SetVirtualOwner( MyID, target )
					end
					step = false	-- Xebv1֖߂
				else
					step = true 	-- Xebv2֐i
				end
				return true
			else
				step = false	-- ̎菇OĂ烊Zbg
				return false
			end
		end )
end

SetSkillConfig( 1, { SKILL_MOONLIGHT, SKILL_CAPRICE },
	function( id )
		Settings.AI_ACTIVE = true
		TraceAI("Change Active")
	end )
SetSkillConfig( 2, { SKILL_MOONLIGHT, SKILL_CAPRICE },
	function( id )
		Settings.AI_ACTIVE = false
		TraceAI("Change Nonactive")
	end )

do -- Autoheal script
		local t = GetTick()
		local Autopot = true
		
		SetKeyConfig( 2, 49, function() if Autopot then Autopot = false else Autopot = true end TraceAI("Ctrl+1") end )

		SetEvent( EVENT_BEGIN_STATE,
		le( bind( GetPercentHP, ref("MyID") ), Settings.POTION_HP_LEVEL ),	-- HPȉȂ
		function()
			t2 = GetTick()
			if t + Settings.POTION_MAX_RATE < t2  then
				if Autopot == true then
					SkillObject(MyID, Settings.POTION_LEVEL, 231, MyID)
					t = GetTick()
				end
			end		
		end )
end
	
-- Control key usage through aiinput.exe.
-- The 2 refers to the modifier key (ctrl in this case), and the next number is the key number.
SetKeyConfig( 2, 50, function() SkillObject( MyID, 3, 231, MyID ) TraceAI("Ctrl+2") end )
SetKeyConfig( 2, 51, function() SkillObject( MyID, 4, 231, MyID ) TraceAI("Ctrl+3") end )
SetKeyConfig( 2, 52, function() SkillObject( MyID, 1, 153, MyID ) TraceAI("Ctrl+4") end )
SetKeyConfig( 2, 53, function() SkillObject( MyID, 1, 247, MyID ) TraceAI("Ctrl+5") end )
--SetKeyConfig( 2, 54, function() TraceAI("Ctrl+6") end )
--SetKeyConfig( 2, 55, function() TraceAI("Ctrl+7") end )
--SetKeyConfig( 2, 56, function() TraceAI("Ctrl+8") end )
--SetKeyConfig( 2, 57, function() TraceAI("Ctrl+9") end )