
var ForReading = 1
var ForWriting = 2

var sh = new ActiveXObject("WScript.Shell");
var fso = new ActiveXObject("Scripting.FileSystemObject");

function MakeLuaFile( mapcode ){
	var path = fso.BuildPath( sh.CurrentDirectory, "MAP");
	if( ! fso.FolderExists( path ) ){
		fso.CreateFolder( path );
	}
	var os = fso.OpenTextFile( fso.BuildPath( path, "current_mapcode.lua"), ForWriting, true );
	os.Write("return ");
	os.Write( mapcode ? "\""+ mapcode +"\"" : "nil" );
	os.WriteLine();
	os.Close();
}

function InitClickableMap( map ){
	var area = map.getElementsByTagName("area");
	for( var i = 0; i < area.length; i++ ){
		area[i].onclick = function(){
			var mapcode = this.title;
			document.getElementById("mapcode").innerHTML = mapcode;
			MakeLuaFile( mapcode );
			return false;
		};
	}
}

window.onload = function(){
	InitClickableMap( document.getElementById("map_dun1") );
	InitClickableMap( document.getElementById("map_dun2") );
	
	document.getElementById("mapcode").onclick = function(){
		this.innerHTML = "none";
		MakeLuaFile();
		return false;
	};
};

window.resizeTo( 425, 575 );

//window.resizeTo( 500, 75 );	// ~j[h
